<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh-tw/HowTos/Virtualization/Vserver</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh-tw/HowTos/Virtualization/Vserver</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh-tw"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867">
<h1 id="CentOS_5.x_.2BTgp2hA_Linux-VServer">CentOS 5.x 上的 Linux-VServer</h1>
<span class="anchor" id="line-4"></span><span class="anchor" id="line-5"></span><p class="line867">&lt;&lt;TableOfContents: execution failed [Argument "maxdepth" must be an integer value, not "[1]"] (see also the log)&gt;&gt; <span class="anchor" id="line-6"></span><span class="anchor" id="line-7"></span><div><table><tbody><tr>  <td class="lmimg red" style="text-align: center"><p class="line862"> <img alt="ArtWork/WikiDesign/alert.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/alert.png" title="ArtWork/WikiDesign/alert.png" /> </td>
  <td class="lmtxt red" colspan="2" style="text-align: left"><p class="line862"> CentOS 的開發者花費很多時間及功夫來確保 CentOS 是穩定的，並適用於生產環境內。採用 VServer 意味著使用不受支援的內核。它除了影響 <a href="./zh(2d)tw(2f)HowTos(2f)KVM.html">KVM</a> 模擬多個處理器的能力外，本作者未發現有其它問題。這並不等於你不會遇上問題，因此請自行承擔下面帶來的風險。 </td>
</tr>
</tbody></table></div><span class="anchor" id="line-8"></span><span class="anchor" id="line-9"></span><p class="line862">這個 wiki 上有另一篇文章更詳盡地解釋採用不受支援的內核的風險。如果你準備在生產設備上使用 VServer，請先 <a href="./zh(2d)tw(2f)HowTos(2f)Custom_Kernel.html">閱讀它</a>。 <span class="anchor" id="line-10"></span><span class="anchor" id="line-11"></span><p class="line874">儘管如此，VServer 的人們當然也在它們的內核上花了不少功夫。本作者在測試的機器上執行了各款的程式，而除了 KVM-qemu 的 smp 問題外，並沒有遇到其它問題。最重要的一點就是 CentOS 的開發者只能官方地支援 CentOS 的內核。 <span class="anchor" id="line-12"></span><span class="anchor" id="line-13"></span><p class="line867"><hr class="hr1" /><p class="line874"> <span class="anchor" id="line-14"></span><a class="http" href="http://linux-vserver.org/Welcome_to_Linux-VServer.org">Linux-VServer</a> 與一個 <a class="http" href="http://www.scottro.net/qnd/qnd-jail.html">FreeBSD 監獄</a>非常相似。它並不像 <a class="http" href="http://virtualbox.org/">VirtualBox</a> 或 <a class="http" href="http://www.vmware.com/">VMware</a> 般是台虛擬機器，反而更像一個複雜的 chroot 環境。它可以在執行網頁伺服器等程式時加入略外一層保障。你可以為客端系統設定資源應用的上限。按預設值，它會動態地分享主機的記憶體及處理器，並以接近原生的速度運行。 <span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><p class="line862">VServer 的網頁內備有<a class="http" href="http://linux-vserver.org/Overview#Types_of_Virtualization">一篇文章</a>解釋不同的虛擬化方式，以及在<a class="http" href="http://linux-vserver.org/Usage_Scenarios">一頁</a>裡列出它在哪些情況下是個好的選擇。 <span class="anchor" id="line-17"></span><span class="anchor" id="line-18"></span><p class="line874">這個網站備有大量文檔。這篇文章的不少篇幅來自該處。 <span class="anchor" id="line-19"></span><span class="anchor" id="line-20"></span><p class="line867">
<h2 id="A.2BbpZQmVuJiN0-">1. 準備安裝</h2>
<span class="anchor" id="line-21"></span><p class="line874">進行安裝前，主機上必須先完成數件事情。簡單來說：新增 yum 軟件庫、下載內核、及修改主機的某些設定。 <span class="anchor" id="line-22"></span><span class="anchor" id="line-23"></span><p class="line867">
<h3 id="A.2BZbBYng_yum_.2Bjt9O9l6r-">1.1. 新增 yum 軟件庫</h3>
<span class="anchor" id="line-24"></span><p class="line862">在 /etc/yum/repos.d 內建立一個新檔案。<a class="http" href="http://linux-vserver.org/Installation_on_CentOS">VServer 的 wiki 文章</a>稱它為 dhozac-verser.repo。這個檔案的內容有 <span class="anchor" id="line-25"></span>{{{[dhozac-vserver] <span class="anchor" id="line-26"></span>name=Linux-VServer related packages for CentOS $releasever - $basearch <span class="anchor" id="line-27"></span>baseurl=<a class="http" href="http://rpm.hozac.com/dhozac/centos/$releasever/vserver/$basearch">http://rpm.hozac.com/dhozac/centos/$releasever/vserver/$basearch</a> <span class="anchor" id="line-28"></span>gpgkey=<a class="http" href="http://rpm.hozac.com/conf/keys/RPM-DHOZAC-GPG-KEY">http://rpm.hozac.com/conf/keys/RPM-DHOZAC-GPG-KEY</a>}}} <span class="anchor" id="line-29"></span><span class="anchor" id="line-30"></span><p class="line874">本篇 wiki 建議你在進行任何動作前先更新 yum。 <span class="anchor" id="line-31"></span><span class="anchor" id="line-32"></span><p class="line867"><tt>yum&nbsp;update&nbsp;yum</tt> <span class="anchor" id="line-33"></span><span class="anchor" id="line-34"></span><p class="line874">請留意自 12 月底，dhozac 這個軟件庫經常無法被運用。在這個情況下 <span class="anchor" id="line-35"></span><span class="anchor" id="line-36"></span><span class="anchor" id="line-37"></span><pre><span class="anchor" id="line-1"></span>baseurl=http://rpm.hozac.com/dhozac/centos/$releasever/vserver/$basearch</pre><span class="anchor" id="line-38"></span><p class="line874">可以臨時被替換為 <span class="anchor" id="line-39"></span><span class="anchor" id="line-40"></span><span class="anchor" id="line-41"></span><pre><span class="anchor" id="line-1-1"></span>baseurl=http://mirror.fubra.com/rpm.hozac.com/dhozac/centos/$releasever/vserver/$basearch</pre><span class="anchor" id="line-42"></span><p class="line867">
<h3 id="A.2BU9Zflw_VServer_.2BUWdoOA-">1.2. 取得 VServer 內核</h3>
<span class="anchor" id="line-43"></span><span class="anchor" id="line-44"></span><p class="line874">下一步是要取得 vs 內核。它的版本比 CentOS 所採用的更要新，因此只要執行 <span class="anchor" id="line-45"></span><span class="anchor" id="line-46"></span><p class="line867"><tt>yum&nbsp;update&nbsp;kernel&nbsp;kernel-devel</tt> <span class="anchor" id="line-47"></span><span class="anchor" id="line-48"></span><span class="anchor" id="line-49"></span><span class="anchor" id="line-50"></span><p class="line874">便會下載 VServer 的內核，截至本文是 2.6.22.19-vs2.3.0.34.1。kernel-devel 這個 rpm 對重建或許會有幫助，否則你也許不需要它。安裝時一個新的項目將會自動被加進 grub。 <span class="anchor" id="line-51"></span><span class="anchor" id="line-52"></span><p class="line867">
<h2 id="A.2BZvRlOU47al.2BKLVua-">2. 更改主機設定</h2>
<span class="anchor" id="line-53"></span><span class="anchor" id="line-54"></span><p class="line862">假若讀者擁有任何第三方的模塊，它們必須針對新的內核被重新建立。截至本文，支援漸趨流行的 Realtek 內置網絡配接卡的 r8168 模塊是其中之一。（這個情況應該在上游供應者的下個版本會有所改善，它大概會在 2008 年 6 月中旬被引進 CentOS。）假若你採用 <a class="http" href="http://wiki.centos.org/Repositories/RPMForge">rpmforge</a> 的 dkms 版本，事情就相當簡單。 <span class="anchor" id="line-55"></span><span class="anchor" id="line-56"></span><p class="line874">當新版內核被安裝後，它在 /lib/modules 內會有一個新的目錄。為了方便輸入，現時的 2.6.18-53.1.19.e15 版的 CentOS 內核將會被縮寫成 2.6.18，而 VServer 的內核將會被縮寫成 2.6.22-vs。請在 /lib/modules 內使用真實的名稱，而不是這裡的縮寫。 <span class="anchor" id="line-57"></span><span class="anchor" id="line-58"></span><p class="line874">r8168 這個模塊將會在 /lib/modules/2.6.18/extras 之內。請將它複製到新內核的 /lib/modules 位置，然後執行 depmod。 <span class="anchor" id="line-59"></span><span class="anchor" id="line-60"></span><p class="line874">{{{cd /lib/modules <span class="anchor" id="line-61"></span>cp 2.6.19/extras/r8168.ko 2.6.22-vs/extras <span class="anchor" id="line-62"></span>depmod 2.6.22-vs}}} <span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><p class="line874">這個模式應該適用於任何 dkms 模塊。 <span class="anchor" id="line-65"></span><span class="anchor" id="line-66"></span><p class="line874">至於 NVidia，或任何從該生產商的網站下載的模塊，它們很可能都須要在啟動新內核後重建。因此，假若相關的模塊是為網絡卡而設，在重新開機前請確定已經下載了所需的檔案。 <span class="anchor" id="line-67"></span><span class="anchor" id="line-68"></span><p class="line874">在安裝前的另一個考慮，就是你若果要以 ssh 來存取虛擬客端系統，你必須編輯主機的 /etc/ssh/sshd_config 檔案。它的預設值是在所有位址聆聽。然而，客端系統將會擁有自己的位址，因此請編輯主機的 sshd_config 令它只在自己（主機）的位址上聆聽。請修改 /etc/ssh/sshd_config 內這一行 <span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><p class="line867"><tt>#ListenAddress&nbsp;0.0.0.0</tt> <span class="anchor" id="line-71"></span><span class="anchor" id="line-72"></span><span class="anchor" id="line-73"></span><p class="line862">刪除 # 號來去掉它的註釋，然後將 <a class="nonexistent" href="./ListenAddress.html">ListenAddress</a> 改為主機的 IP。假如主機的 IP 位置是 192.168.1.80，這一行便成為 <span class="anchor" id="line-74"></span><span class="anchor" id="line-75"></span><p class="line867"><tt>ListenAddress&nbsp;192.168.1.80</tt> <span class="anchor" id="line-76"></span><span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><p class="line874">接著重新啟動 ssh。 <span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><p class="line867"><tt>/etc/init.d/sshd&nbsp;restart</tt> <span class="anchor" id="line-81"></span><span class="anchor" id="line-82"></span><p class="line874">安裝一些應用客端系統時所需的套件。 <span class="anchor" id="line-83"></span><span class="anchor" id="line-84"></span><p class="line867"><span class="anchor" id="line-85"></span><span class="anchor" id="line-86"></span><span class="anchor" id="line-87"></span><span class="anchor" id="line-88"></span><pre><span class="anchor" id="line-1-2"></span>yum install util-vserver{,-core,-lib,-sysv,-build}</pre><span class="anchor" id="line-89"></span><span class="anchor" id="line-90"></span><span class="anchor" id="line-91"></span><p class="line874">在 /etc/init.d 內將會有個新的項目。請將 vprocunhide 及 util-vserver 設定為開機時啟動。（這一步在安裝時可能已經完成。） <span class="anchor" id="line-92"></span>{{{chkconfig util-vserver on <span class="anchor" id="line-93"></span>chkconfig vprocunhide on}}} <span class="anchor" id="line-94"></span><span class="anchor" id="line-95"></span><span class="anchor" id="line-96"></span><p class="line874">用新的內核重新開機。 <span class="anchor" id="line-97"></span><span class="anchor" id="line-98"></span><p class="line867">
<h2 id="A.2BW4mI3Vuieu98.2B31x-">3. 安裝客端系統</h2>
<span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span><p class="line862">VServer 在<a class="http" href="http://linux-vserver.org/Building_Guest_Systems">關於建立客端系統的文檔內</a>提供了數個方法。在這個範例中，我們將會安裝一台 CentOS 客端系統。就 CentOS 來說，利用範本及採用 yum 是最簡單的兩個方法。 <span class="anchor" id="line-101"></span><span class="anchor" id="line-102"></span><p class="line862">現時已經有一個範本可用來安裝最基本的 CentOS。你可以從 <a class="http" href="http://mirrors.sandino.net/vserver/images/">sandio.net</a> 下載映像並採用範本這個方法。截至本文，現時只備有 32 位元的範本作為 CentOS 5.x 映像。 <span class="anchor" id="line-103"></span><span class="anchor" id="line-104"></span><p class="line874">採用這個方法時請將範本，一個 tar.bz2 映像，儲存在某處。（VServer 的文檔以 /vservers/.templates 為例。）請勿將它解壓，因該檔案會在建立過程中被直接應用。 <span class="anchor" id="line-105"></span><span class="anchor" id="line-106"></span><p class="line874">這個範本亦可以應用在其它系統上。譬如你在 Fedora 上安裝了 VServer 的內核，你亦可以建立一台 CentOS 客端系統。 <span class="anchor" id="line-107"></span><span class="anchor" id="line-108"></span><p class="line874">在下列範例中，我們將客端系統命名為 vcentos。它的區域是 example.com。請將所有 vcentos 改為你的伺服器的名稱，並以你的域名代替 example.com。這個指令必須在同一行內輸入。（視乎畫面大小及解像度，很多瀏覽器會將它顯示為數行。） <span class="anchor" id="line-109"></span><span class="anchor" id="line-110"></span><p class="line874">{{{vserver vcentos build -m template --hostname vcentos.example.com <span class="anchor" id="line-111"></span>--interface eth0:192.168.1.70/24 -- -d centos5 -t <span class="anchor" id="line-112"></span>/vservers/.templates/centos-5-i686-2007-07-14.tar.bz2}}} <span class="anchor" id="line-113"></span><span class="anchor" id="line-114"></span><p class="line867">
<h4 id="A.2BieORyw-">3.0.1. 解釋</h4>
<span class="anchor" id="line-115"></span><p class="line874">vserver vcentos。客端系統去掉區域的名稱。請把它改為你選擇給客端系統的名稱。 <span class="anchor" id="line-116"></span><span class="anchor" id="line-117"></span><p class="line874">build -m template。-m 代表「方法」。在這個例子裡，要以範本的方法進行建立。 <span class="anchor" id="line-118"></span><span class="anchor" id="line-119"></span><p class="line874">--hostname。客端系統的完整機名，連同域名在內。 <span class="anchor" id="line-120"></span><span class="anchor" id="line-121"></span><p class="line874">--interface eth0:192.168.1.70/24。客端系統的網絡介面及 IP 位址。它應該與主機位於同一個子網絡。在這個範例裡，我們採用典型的 192.168.1.0/24 子網絡。（對於那些不熟識這個寫法的人，它與意思等同一個 255.255.255.0 的子網遮罩。） <span class="anchor" id="line-122"></span><span class="anchor" id="line-123"></span><p class="line874">-- -d centos5。-- 是一個分隔符號，接著是你的發行版本的名稱。如果你下載了一個 Fedora 8 的映像，你應該用 -d fedora8。 <span class="anchor" id="line-124"></span><span class="anchor" id="line-125"></span><p class="line874">這個 -- 並非錯字。build 這個指令分為不同部份，而它們是以 -- 隔開的。等一部份是基本選項的設定，在這個例子中包括開頭一切至 --interface。第二部份以 -- 隔開，所提供的是發行版本，以及在這個例子的範本位置。 <span class="anchor" id="line-126"></span><span class="anchor" id="line-127"></span><p class="line874">-t /vservers/.templates/centos-5-i686-2007-07-14.tar.bz2。-t 代表要應用的範本，因此請列出範本的完整路徑。 <span class="anchor" id="line-128"></span><span class="anchor" id="line-129"></span><p class="line867">
<h4 id="A.2BkA.2BQTg_yum_.2BkDKITFuJiN0-">3.0.2. 透過 yum 進行安裝</h4>
<span class="anchor" id="line-130"></span><span class="anchor" id="line-131"></span><p class="line874">若要安裝 64 位元的 CentOS 客端系統（只可在 64 位元主機上進行），請以 yum 的方法進行安裝。 <span class="anchor" id="line-132"></span><span class="anchor" id="line-133"></span><p class="line874">{{{vserver vcentos build -m yum --hostname vcentos.example.com <span class="anchor" id="line-134"></span>--interface eth0:192.168.1.70/24 -- -d centos5}}} <span class="anchor" id="line-135"></span><span class="anchor" id="line-136"></span><span class="anchor" id="line-137"></span><p class="line874">這樣做會進行最細小的安裝，當中只包括基本系統、gcc 及少數其它東西。 <span class="anchor" id="line-138"></span><span class="anchor" id="line-139"></span><p class="line874">要安裝  Fedora 8 的客端系統，請將 -d 的值改為 f8。一個可用的發行版本清單已經收錄在 /usr/lib/util-vserver/distributions。（在 64 位元主機上，這個清單位於 /usr/lib64/util-vserver/distributions。） <span class="anchor" id="line-140"></span><span class="anchor" id="line-141"></span><p class="line867">
<h2 id="A.2Bii1bmluieu98.2B31x-">4. 設定客端系統</h2>
<span class="anchor" id="line-142"></span><span class="anchor" id="line-143"></span><p class="line867">
<h3 id="A.2BWVdO9nuhdAY-">4.1. 套件管理</h3>
<span class="anchor" id="line-144"></span><p class="line874">剛安裝好的客端系統屬最小的系統。假若你以範本來建立它，最基本的指令都應該全備，但如果你利用 yum 來建立它，less、which、passwd 及 vi 等指令都不存在。你可以從主機或在客端系統內管理套件。 <span class="anchor" id="line-145"></span><span class="anchor" id="line-146"></span><p class="line874">要從主機管理套件，請使用 vyum 指令。它的語法是 <span class="anchor" id="line-147"></span><span class="anchor" id="line-148"></span><p class="line867"><tt>vyum&nbsp;&lt;servername&gt;&nbsp;--&nbsp;install&nbsp;&lt;package_name&gt;</tt> <span class="anchor" id="line-149"></span><span class="anchor" id="line-150"></span><span class="anchor" id="line-151"></span><p class="line874">譬如說我們要在客端系統上安裝 passwd 這個指令 <span class="anchor" id="line-152"></span><span class="anchor" id="line-153"></span><p class="line867"><tt>vyum&nbsp;vcentos&nbsp;--&nbsp;install&nbsp;passwd</tt> <span class="anchor" id="line-154"></span><span class="anchor" id="line-155"></span><span class="anchor" id="line-156"></span><p class="line874">你會看見一個典型的對話方塊，用來顯示將會被下載的套件，並要求你確認。輸入 y 或 yes 後，你將會看見被些套件被安裝。  <span class="anchor" id="line-157"></span><span class="anchor" id="line-158"></span><p class="line874">對於透過 yum 建立的系統，就算它們不在運行中依然可以應用這個指令。 <span class="anchor" id="line-159"></span><span class="anchor" id="line-160"></span><p class="line874">然而，假若套件的名稱不正確，例如你錯誤輸入 vi 而要是 vim-minimal 或 vim-enhanced，除了看不見典型的 yum 對話方塊外，你不會收到任何關於失敗的通知。它可能會短暫地停頓，然後便返回指令符。假如你看不見典型的 yum 對話方塊，那麼該套件便沒有被安裝。若果你提供了錯誤的套件名稱，你或許會看見典型的 yum 對話方塊以 Nothing to do 這個信息來結束，但這並非必然。 <span class="anchor" id="line-161"></span><span class="anchor" id="line-162"></span><span class="anchor" id="line-163"></span><span class="anchor" id="line-164"></span><p class="line874">如果你以 yum 安裝方法來建立了一台客端系統，然後想在客端系統內管理套件，你首先要安裝 yum 及 vyum。接著請執行 <span class="anchor" id="line-165"></span><span class="anchor" id="line-166"></span><p class="line874">{{{verserver pkgmgmt internalize. vyum vcentos -- install yum <span class="anchor" id="line-167"></span>vserver vcentos pkgmgmt internalize}}} <span class="anchor" id="line-168"></span><span class="anchor" id="line-169"></span><span class="anchor" id="line-170"></span><p class="line874">如果 yum 未被正確地安裝，pkgmgmt 這個指令會匯報錯誤。 <span class="anchor" id="line-171"></span><span class="anchor" id="line-172"></span><p class="line874">假若客端系統是從範本所建立的，以上的步驟都是不必要的。 <span class="anchor" id="line-173"></span><span class="anchor" id="line-174"></span><p class="line867">
<h2 id="A.2BkDJOAGtldoSKLVua-">5. 進一步的設定</h2>
<span class="anchor" id="line-175"></span><p class="line874">客端系統的檔案都放置在 /etc/vserver/vcentos/vdir。你可以在啟動伺服器前編輯它們。（請記得 vcentos 是我們的範例伺服器名稱，你應該改用你的伺服器名稱。） <span class="anchor" id="line-176"></span><span class="anchor" id="line-177"></span><p class="line874">啟動客端系統。 <span class="anchor" id="line-178"></span><span class="anchor" id="line-179"></span><p class="line867"><tt>vserver&nbsp;vcentos&nbsp;start</tt> <span class="anchor" id="line-180"></span><span class="anchor" id="line-181"></span><span class="anchor" id="line-182"></span><p class="line874">請進入你的伺服器作進一步的設定 <span class="anchor" id="line-183"></span><span class="anchor" id="line-184"></span><p class="line867"><tt>vserver&nbsp;vcentos&nbsp;enter</tt> <span class="anchor" id="line-185"></span><span class="anchor" id="line-186"></span><span class="anchor" id="line-187"></span><p class="line874">你將會被放在一個指令提示元。預設的安裝裡沒有 /etc/shadow，因此你無法更改 root 的密碼。要解決這個問題，假設你已利用 vyum 安裝了 passwd 這個指令（或者 yum，在已安裝了 yum 的客端系統），請執行 <span class="anchor" id="line-188"></span><span class="anchor" id="line-189"></span><p class="line867"><tt>pwconv</tt> <span class="anchor" id="line-190"></span><span class="anchor" id="line-191"></span><span class="anchor" id="line-192"></span><p class="line874">如此 /etc/shadow 這個檔案便會被建立。你現在可以透過正常做法為 root 設置一個密碼。 <span class="anchor" id="line-193"></span><span class="anchor" id="line-194"></span><p class="line862">若然你計劃透過 ssh 存取客端系統，（預設不會在客端上安裝 —— 你需要安裝 openssh-server 及客戶端），客端系統上的 /etc/pam.d/sshd 必須被修改。請遵從 <a class="http" href="http://linux-vserver.org/Frequently_Asked_Questions#Why_do_neither_sshd_nor_crond_.28vixie-cron.29_work_correctly_in_my_CentOS_.2F_Fedora_guest.3F_I_get_.27pam_loginuid.28crond:session.29:_set_loginuid_failed_opening_loginuid.27_and_similar_lines_in_my_logs.">VServer 常見問題集</a>，在 CentOS 及 Fedora 客端系統上將 /etc/pam.d/sshd 檔內的最後一行註釋掉。它的內容是 <span class="anchor" id="line-195"></span><tt>session&nbsp;&nbsp;&nbsp;&nbsp;required&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;pam_loginuid.so</tt> <span class="anchor" id="line-196"></span><span class="anchor" id="line-197"></span><span class="anchor" id="line-198"></span><span class="anchor" id="line-199"></span><span class="anchor" id="line-200"></span><p class="line874">請在行首加入 # 符號將它註釋掉。 <span class="anchor" id="line-201"></span><span class="anchor" id="line-202"></span><p class="line874">此刻，你可以一如其它 CentOS 系統般設定你的客端系統。舉個例說，如果你是要通過 VServer 為你的網頁伺服器加上額外一層保障，現在你便可以安裝 httpd 並在設定客端系統上的相關檔案。 <span class="anchor" id="line-203"></span><span class="anchor" id="line-204"></span><p class="line867">
<h2 id="A.2BVyhOO2pfVV9S1WZCV.2FeITA_VServer">6. 在主機啟動時執行 VServer</h2>
<span class="anchor" id="line-205"></span><span class="anchor" id="line-206"></span><p class="line874">要在你的主機啟動時啟動預設的 vserver 客端系統，請先啟用 /etc/init.d/vserver-default 這個腳本。 <span class="anchor" id="line-207"></span><span class="anchor" id="line-208"></span><p class="line867"><tt>chkconfig&nbsp;vserver-default&nbsp;on</tt> <span class="anchor" id="line-209"></span><span class="anchor" id="line-210"></span><span class="anchor" id="line-211"></span><p class="line874">接著進到 /etc/vservsers/vcentos/apps/init。（請以你的伺服器名稱替代 vcentos。） <span class="anchor" id="line-212"></span><span class="anchor" id="line-213"></span><p class="line867"><tt>echo&nbsp;default&nbsp;&gt;&nbsp;mark</tt> <span class="anchor" id="line-214"></span><span class="anchor" id="line-215"></span><p class="line874">換句話說，你會建立一個名為 mark 的檔案，當中包含 default 這個單字。下次你啟動主機系統時，名叫 vcentos 的 Vserver 客端系統亦會啟動。 <span class="anchor" id="line-216"></span><span class="anchor" id="line-217"></span><p class="line874">這是一個頗簡單的介紹。你亦可執行多台機器、限制一台機器所應用的資源、與及其它事情。我們建議讀者瀏覽 VServer 的網頁來取得更多資訊。 <span class="anchor" id="line-218"></span><span class="anchor" id="line-219"></span><p class="line862">（這篇文章的原稿已收錄在 <a class="http" href="http://home.roadrunner.com/~computertaijutsu/vserver.html">http://home.roadrunner.com/~computertaijutsu/vserver.html</a>） <span class="anchor" id="line-220"></span><span class="anchor" id="line-221"></span><p class="line867"><small>Translation of revision 12</small> <span class="anchor" id="line-222"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
